int RowLed[7] = {2,3,4,5,6,7,8};        //Cathode connection points
int colLed[5] = {15,16,17,18,19};       //Anode connection Points

int Rpin = 6;                           //Total cathode pins
int cpin = 4;                           //Total anode pins

void setup()                
{
  for (int i = 0; i <= Rpin; i++) 
  {
    pinMode(RowLed[i], OUTPUT);
  }
  
  for (int j = 0; j <= cpin; j++) 
  {
    pinMode(colLed[j], OUTPUT);
  }
}

void alloff() 
{
  
  for (int i = 0; i <= Rpin; i++) 
  {
    digitalWrite(RowLed[i],LOW);
  }
  
  for (int j = 0; j <= cpin; j++) 
  {
   digitalWrite(colLed[j],HIGH);
  }

}  

void ledon(int x, int y) 
{
  alloff();                             //first the turn off function is called to make sure that only that led is ON.
  digitalWrite(RowLed[x], HIGH);        //Makes the anode pin of the particular LED at +5 V
  digitalWrite(colLed[y], LOW);         //Makes the cathode pin of the particular LED at 0V 

}

/*   A function to display the letter B
    The corresponding leds are addressed here with a delay of 1 microsecond.   
*/
void L_B()
{
  
  ledon(0,0);delay(1);
  ledon(1,0);delay(1);
  ledon(2,0);delay(1);
  ledon(3,0);delay(1);
  ledon(4,0);delay(1);
  ledon(5,0);delay(1);
  ledon(6,0);delay(1);
  ledon(0,1);delay(1);
  ledon(0,2);delay(1);
  ledon(0,3);delay(1);
  ledon(1,4);delay(1);
  ledon(2,4);delay(1);
  ledon(3,0);delay(1);
  ledon(3,1);delay(1);
  ledon(3,2);delay(1);
  ledon(3,3);delay(1);
  ledon(4,4);delay(1);
  ledon(5,4);delay(1);
  ledon(6,0);delay(1);  
  ledon(6,1);delay(1);
  ledon(6,2);delay(1);
  ledon(6,3);delay(1);
}

void L_E()
{
  
  ledon(0,0);delay(1);
  ledon(1,0);delay(1);
  ledon(2,0);delay(1);
  ledon(3,0);delay(1);
  ledon(4,0);delay(1);
  ledon(5,0);delay(1);
  ledon(6,0);delay(1);
  ledon(0,1);delay(1);
  ledon(0,2);delay(1);
  ledon(0,3);delay(1);
  ledon(0,4);delay(1);
  ledon(3,0);delay(1);
  ledon(3,1);delay(1);
  ledon(3,2);delay(1);
  ledon(3,3);delay(1);
  ledon(3,4);delay(1);
  ledon(6,0);delay(1);  
  ledon(6,1);delay(1);
  ledon(6,2);delay(1);
  ledon(6,3);delay(1);
  ledon(6,4);delay(1);

}


void L_P()
{
  ledon(0,0);delay(1);
  ledon(1,0);delay(1);
  ledon(2,0);delay(1);
  ledon(3,0);delay(1);
  ledon(4,0);delay(1);
  ledon(5,0);delay(1);
  ledon(6,0);delay(1);
  ledon(0,1);delay(1);
  ledon(0,2);delay(1);
  ledon(0,3);delay(1);
  ledon(1,4);delay(1);
  ledon(2,4);delay(1);
  ledon(3,0);delay(1);
  ledon(3,1);delay(1);
  ledon(3,2);delay(1);
  ledon(3,3);delay(1);
}

void BEP()
{
  for(int i=0;i<=50;i++)
  {
    L_B();
  }
  alloff();
  delay(200);
  for(int i=0;i<=50;i++)
  {
    L_E();
  }
  alloff();
  delay(200);
  for(int i=0;i<=50;i++)
  {
   L_P();
  }
  alloff();
  delay(200);
}

void loop() 
{
  BEP();
}
